{$IFDEF Windows}
  {$DEFINE WINDOWS_AND_DPMI}
{$ENDIF}

{$IFDEF DPMI}
  {$DEFINE WINDOWS_AND_DPMI}
{$ENDIF}

{[]---------------------------------------------------------[]}
{|                    COMINT2F.PAS                           |}
{+-----------------------------------------------------------+}
{|                                                           |}
{|  㭨樨  १ ᮬ १ INT 2Fh |}
{|                                                           |}
{|  4.01                                       SVsw    |}
{|                                                           |}
{[]---------------------------------------------------------[]}

{$A-,O-,B-,R-,V-,I-,S-,F-,X+}

unit
  ComInt2F;

interface

const
  fCarry     = $0001;
  fParity    = $0004;
  fAuxiliary = $0010;
  fZero      = $0040;
  fSign      = $0080;
  fOverflow  = $0800;

type
    {**** -⥫ १⭮  ****}
  PProcessBlock  = ^TProcessBlock;
  TProcessBlock     = record
    Id           : longint;  { 䨪 }
    Multiplexor  : byte;     { ⨯ int 2Fh }
    Handle       : word;     { 奭 }
    Version      : word;     {  (訩  - ,
                                       訩  -  }
    PSP          : word;     { 䨪 ணࠬ ᥣ }
    Name         : pointer;  { 㪠⥫  ASCIZ- }
  end;

{$IFDEF WINDOWS_AND_DPMI}

  TCpuRegisters = record
    case Integer of
      0 : (EDI, ESI, EBP : longint;
           Dummy0 : longint;
           EBX, EDX, ECX, EAX : longint;
           Flags, ES, DS, FS, GS, IP, CS, SP, SS : word
          );
      1 : (DI, DIDummy1, SI, SIDummy1, BP, BPDummy1 : word;
           Dummy1 : longint;
           BX, BXDummy1, DX, DXDummy1, CX, CXDummy1, AX, AXDummy1 : word
          );
      2 : (Dummy2 : array[0..3] of longint;
           BL, BH : byte; BXDummy2 : word;
           DL, DH : byte; DXDummy2 : word;
           CL, CH : byte; CXDummy2 : word;
           AL, AH : byte; AXDummy2 : word
          );
  end;

{$ELSE}

  TCpuRegisters = record
    case Integer of
    0: (AX, BX, CX, DX, BP, SI, DI, DS, ES, Flags: Word);
    1: (AL, AH, BL, BH, CL, CH, DL, DH: Byte);
  end;

  TIntRegisters = record
    case byte of
      1 : (BP, ES, DS, DI, SI, DX, CX, BX, AX, IP, CS, Flags : word);
      2 : (Dummy : array[0..4] of word;
           DL, DH, CL, CH, BL, BH, AL, AH : byte);
  end;

  TSelfInt           = function : boolean;
  TResetInt          = procedure;
  TRestoreInt        = procedure;
  TCommunication     = procedure; {   ᠭ  interrupt
        procedure Communication(StackTop : word); interrupt;
        var
          IntRegs : TIntRegisters absolute StackTop;
        begin
          .....
        end; }

  TInitProcessBlock = (ipbOk,                     { OK ! }
                       ipbMultiplexorsBusy,       { FATAL }
                       ipbHandlersBusy,
                       ipbIncorrectDosVersion,
                       ipbAlreadyInstalled,        { WARNING }
                       ipbOtherVersionInstalled
                      );
{$ENDIF}

function LastProcessBlock : PProcessBlock;
  { 㪠⥫  -⥫ ᫥ १⭮ 
     nil, ᫨   १   ⠭ }

function ProcessBlockByName(const Name : string) : PProcessBlock;
  { 頥 㪠⥫  -⥫ १⭮    
     nil, ᫨   ⠭ }

function ProcessBlockByHandle(Handle : word) : PProcessBlock;
  { 頥 㪠⥫  -⥫ १⭮   奭
     nil, ᫨   ⠭ }

function ComProcAvail(PB : PProcessBlock) : boolean;
  { 頥 True, ᫨ १   楤 㭨樨 }

function ProcessInstalled(const Name : string; var PB : PProcessBlock) : boolean;
  { 頥 True, ᫨    Name ⠭,  PB ᮤন
    㪠⥫   -⥫ }

procedure CallProcess(PB : PProcessBlock; var Regs : TCpuRegisters);
  { 뢠 १     ⥫.
     AH  BX  㯭 짮⥫  맮 .
    AL = $00..$03 १ࢨ஢  ७ ᯮ짮 }

{$IFNDEF WINDOWS_AND_DPMI}

procedure ResetIntVec(IntNum : byte; SelfPtr : pointer; var SavePtr : pointer);
  { ࠭  ࠡ稪 뢠 IntNum  SavePtr 
    ⠭   SelfPtr, 㪠騩  楤 ⨯
      procedure IntHandler(StackTop : word); interrupt;
      var
        IntRegs : TIntRegisters absolute StackTop;
      begin
        .....
      end;    }

procedure RestoreIntVec(IntNum : byte; var SavePtr : pointer);
  { ⠭  뢠 IntNum  SavePtr }

function SelfIntVec(IntNum : byte; SelfPtr : pointer) : boolean;
  { 頥 True, ᫨  뢠 IntNum 㪠  SelfPtr }

function InitProcessBlock(
     const AName    : string;  {   }
     AVersion       : word;    {   }
     ACommunication : pointer; { 㪠⥫  interrupt-楤 㭨樨 }
     AResetInt      : pointer; { 㪠⥫  far-楤 ⠭
                                 ஢ 뢠 }
     ARestoreInt    : pointer; { 㪠⥫  far-楤 ⠭
                                 ஢ 뢠 }
     ASelfInt       : pointer  { 㪠⥫  far-㭪, ஢
                                 ᮢ ஢ 뢠 }
    ) : TInitProcessBlock;

function ReleaseProcess : boolean;
  { 頥 True, ᫨  㦥  
     뢠 ⮫쪮  १⭮ !!! }

procedure InstallProcess(ParasToKeep : word; ReleaseEnv : boolean);
  { ⠫ . 室  楤  ⮫쪮 
      㤠筮 ⠫樨. ᫨  ந諮, ᫥ 
       ணࠬ.
    ReleaseEnv 㪠뢠  室 ᢮ ᥣ
      㦥  ⠫樨 }

function ParagraphsToKeep : word;
  { 頥 ⢮ ࠣ䮢,  , 묨,
    ⥪  娯 }

function MaxParagraphsToKeep : word;
  { 頥 ᨬ쭮  ⢮ ࠣ䮢 }

procedure RequiredDosVersion(Major, Minor : byte);
{$ENDIF}

function VersionStr(Version : word) : string;
function ProjectStr(PrjStart, PrjEnd : word) : string;
function Copyright(const Name : string; Version : word;
                   ProjectStart, ProjectEnd : word;
                   const Producer : string) : string;

implementation

{$IFDEF WINDOWS_AND_DPMI}
uses
  WinApi;

function _Int2Fh(var Regs : TCpuRegisters) : word; near; assembler;
asm
    xor     bx,bx
    mov     bl, 2Fh
    xor     cx,cx       {StackWords = 0}
    les     di,Regs
    mov     ax,0300h
    int     31h
    jc      @@ExitPoint
    xor     ax,ax
@@ExitPoint:
end;

function Seg2Dsc(ASeg : word) : word; near; assembler;
asm
      mov   ax,2
      mov   bx, ASeg
      int   31h
end;

function _Ptr(ASeg, AOfs : word) : pointer; near;
begin
  _Ptr := Ptr(Seg2Dsc(ASeg), AOfs);
end;

function IsValidSelector(S: Word): Boolean; near; assembler;
asm
	XOR	AX,AX  { assume failure }
	CMP	S,0    { 386 bug workaround: LAR on a 0 selector doesn't work }
	JE	@1
	LAR	BX,S   { Get Access rights }
	JNZ	@1     { Zero flag is clear if the selector is invalid }
	INC	AX
@1:
end;

function PtrFromHandle(H: THandle): Pointer; near; assembler;
asm
	MOV	DX,H
	AND	DX,0FFF8H
	MOV	AX,DS
	AND	AX,7
	OR	DX,AX
	PUSH	DX
	CALL	IsValidSelector
	OR	AL,AL
	JNZ	@1
	XOR	DX,DX
@1:	XOR	AX,AX
end;

function LastProcessBlock : PProcessBlock;
const
  Id : longint = $17131613;
var
  i : byte;
  SelfId : ^longint;
  TsrPB : PProcessBlock;
  H : longint;
  Regs : TCpuRegisters;
begin
  { 뤥塞   1-   뢠   Id }
  H := GlobalDosAlloc(SizeOf(LongInt));
  if H = 0 then
    begin
      LastProcessBlock := nil;
      Exit;
    end;
  SelfId := PtrFromHandle(LoWord(H));
  Move(Id, SelfId^, SizeOf(longint));
  i := $80;               { 稭   ⨯ 80h }
  repeat
    FillChar(Regs, SizeOf(TCpuRegisters), 0);
    Regs.AH := i;         { AH = ⨯ }
    Regs.DS := HiWord(H); { DS:SI = 㪠⥫  Id}
    _Int2Fh(Regs);
    if Regs.AL = $FF then { ⨯  ? }
      begin               { ... }
        TsrPB := _Ptr(Regs.ES, Regs.DI);
        if TsrPB <> nil then
        if TsrPB^.Id = Id then   { ES:DI 㪠뢠  Id ? }
          begin                  { ... }
            LastProcessBlock := TsrPB;
            Break;
          end;
      end;
    if i = $FF then          {  ⨯ ᬮ५ ? }
      begin                  { ... }
        LastProcessBlock := nil;
        Break;
      end
    else
      Inc(i);
  until False;
  GlobalDosFree(LoWord(H));
end;

function ProcessBlockByName(const Name : string) : PProcessBlock;
var
  PB : PProcessBlock;
  P : pointer;
  H : longint;
  Regs : TCpuRegisters;
begin
  PB := LastProcessBlock;
  if PB <> nil then
    begin
      H := GlobalDosAlloc(SizeOf(String));
      if H = 0 then
        begin
          ProcessBlockByName := nil;
          Exit;
        end;
      P := PtrFromHandle(LoWord(H));
      FillChar(P^, SizeOf(String), 0);
      Move(Name[1], P^, Length(Name));
      FillChar(Regs, SizeOf(TCpuRegisters), 0);
      Regs.AH := PB^.Multiplexor;
      Regs.AL := 1;
      Regs.DS := HiWord(H);
      _Int2Fh(Regs);
      if Regs.BX = 0 then
        PB := nil
      else
        PB := _Ptr(Regs.ES, Regs.DI);
      GlobalDosFree(LoWord(H));
    end;
  ProcessBlockByName := PB;
end;

function ProcessBlockByHandle(Handle : word) : PProcessBlock;
var
  PB : PProcessBlock;
  Regs : TCpuRegisters;
begin
  PB := LastProcessBlock;
  if PB <> nil then
    begin
      Regs.AH := PB^.Multiplexor;
      Regs.AL := 2;
      Regs.BX := Handle;
      Regs.ES := 0;
      Regs.DI := 0;
      _Int2Fh(Regs);
      PB := _Ptr(Regs.ES, Regs.DI);
    end;
  ProcessBlockByHandle := PB;
end;

function ComProcAvail(PB : PProcessBlock) : boolean;
var
  Regs : TCpuRegisters;
begin
  if PB = nil then
    ComProcAvail := False
  else
    begin
      Regs.AL := 3;
      CallProcess(PB, Regs);
      ComProcAvail := (Regs.AL = 0);
    end;
end;

function ProcessInstalled(const Name : string; var PB : PProcessBlock) : boolean;
begin
  PB := ProcessBlockByName(Name);
  ProcessInstalled := PB <> nil;
end;

procedure CallProcess(PB : PProcessBlock; var Regs : TCpuRegisters);
begin
  if PB <> nil then
    begin
      Regs.AH := PB^.Multiplexor;
      Regs.BX := PB^.Handle;
      _Int2Fh(Regs);
    end;
end;

{$ELSE}

procedure _Int2Fh(var Regs : TCpuRegisters); near; assembler;
asm
        LDS    SI, Regs
        CLD
        LODSW                 { ax }
        PUSH   AX
        LODSW                 { bx }
        MOV    BX, AX
        LODSW                 { cx }
        MOV    CX, AX
        LODSW                 { dx }
        MOV    DX, AX
        LODSW                 { bp }
        MOV    BP, AX
        LODSW                 { si }
        PUSH   AX
        LODSW                 { di }
        MOV    DI, AX
        LODSW                 { ds }
        PUSH   AX
        LODSW                 { es }
        MOV    ES, AX
        POP    DS
        POP    SI
        POP    AX
        INT    2Fh
        PUSHF
        PUSH   AX
        PUSH   ES
        PUSH   DI
        PUSH   BP
        MOV    BP, SP
        MOV    AX, [BP + 14]
        MOV    DI, AX
        MOV    AX, [BP + 16]
        MOV    ES, AX
        CLD
        MOV    AX, [BP + 6]       { ax }
        STOSW
        MOV    AX, BX             { bx }
        STOSW
        MOV    AX, CX             { cx }
        STOSW
        MOV    AX, DX             { dx }
        STOSW
        MOV    AX, [BP]           { bp }
        STOSW
        MOV    AX, SI             { si }
        STOSW
        MOV    AX, [BP + 2]       { di }
        STOSW
        MOV    AX, DS             { ds }
        STOSW
        MOV    AX, [BP + 4]       { es }
        STOSW
        MOV    AX, [BP + 8]       { Flags }
        STOSW
        MOV    AX, SEG @DATA
        MOV    DS, AX
        ADD    SP, 10
        MOV    BP, SP
end;

function _DosVersion : word; near; assembler;
asm
           MOV     AH, 30h
           INT     21h
           XCHG    AH, AL
end;

procedure _SetIntVec(IntNum : byte; Vector : pointer); near; assembler;
asm
           PUSH    DS
           MOV     AH, 25h
           MOV     AL, IntNum
           LDS     DX, Vector
           INT     21h
           POP     DS
end;

function _GetIntVec(IntNum : byte) : pointer; near; assembler;
asm
           MOV     AH, 35h
           MOV     AL, IntNum
           INT     21h
           MOV     AX, BX
           MOV     DX, ES
end;

procedure ResetIntVec(IntNum : byte; SelfPtr : pointer; var SavePtr : pointer);
begin
  SavePtr := _GetIntVec(IntNum);
  _SetIntVec(IntNum, SelfPtr);
end;

procedure RestoreIntVec(IntNum : byte; var SavePtr : pointer);
begin
  _SetIntVec(IntNum, SavePtr);
  SavePtr := nil;
end;

function SelfIntVec(IntNum : byte; SelfPtr : pointer) : boolean;
begin
  SelfIntVec := (SelfPtr = _GetIntVec(IntNum));
end;

const
  SelfName : string = '';
  SelfNameLength : word = 0;
  SaveInt2Fh : pointer = nil;       {  ࠭ int 2Fh }
  SelfPB : TProcessBlock =
    (Id          : $17131613;
     Multiplexor : 0;
     Handle      : 0;
     Version     : 0;
     PSP         : 0;
     Name        : @SelfName);
  SelfInt        : TSelfInt         = nil;
  Communication  : TCommunication   = nil;
  ResetInt       : TResetInt        = nil;
  RestoreInt     : TRestoreInt      = nil;
  _RequiredDosVersion : word = $031E;

function LastProcessBlock : PProcessBlock; assembler;
asm
               XOR      AX, AX       { ⮢ १ (nil) }
               PUSH     AX
               PUSH     AX
               MOV      CH, 80h      { 稭  ⨯ 80h }
@@Continue_Point:
               MOV      AH, CH
               XOR      AL, AL       { ஢ઠ ⠫樨 }
               MOV      SI, OFFSET SelfPB  { DS:SI 㪠뢠  SelfPB}
               INT      2Fh
               CMP      AL, 0FFh     { ? }
               JE       @@Check_Id   { ... }
               CMP      CH, 0FFh     {  ᬮ५? }
               JE       @@Exit_Point { ... }
@@Next_Multiplexor:
               INC      CH           { ६ ᫥騩 ⨯ }
               JMP      @@Continue_Point {  ஢塞 ... }
@@Check_Id:
               CLD                   { ES:DI  㪠뢠  Id }
               MOV      BX, DI
               MOV      SI, OFFSET SelfPB
               CMPSW
               JNE      @@Next_Multiplexor
               CMPSW
               JNE      @@Next_Multiplexor
               ADD      SP, 4
               PUSH     ES
               PUSH     BX
@@Exit_Point:
               POP      AX
               POP      DX
end;

var
  TmpName : string;

function ProcessBlockByName(const Name : string) : PProcessBlock; assembler;
asm
            PUSH     DS              { ८ࠧ㥬 Name  ASCIZ }
            LDS      SI, Name
            MOV      AX, SEG @DATA
            MOV      ES, AX
            MOV      DI, OFFSET TmpName
            XOR      CX, CX
            MOV      CL, BYTE PTR DS:[SI]
            OR       CX, CX
            JE       @@Skip_Conversion
            INC      SI
            CLD
            REP      MOVSB
@@Skip_Conversion:
            MOV      BYTE PTR ES:[DI], CL
            POP      DS
            XOR      AX, AX             {  १ (nil) }
            PUSH     AX
            PUSH     AX
            CALL     LastProcessBlock   { 饬 ᫥ - }
            OR       DX, DX             { ? }
            JE       @@Exit_Point       { ... }
            MOV      ES, DX
            MOV      DI, AX
            MOV      AH, ES:[DI].TProcessBlock.Multiplexor
            MOV      AL, 1
            XOR      BX, BX
            MOV      SI, OFFSET TmpName
            INT      2Fh
            OR       BX, BX             { ? }
            JE       @@Exit_Point       { ... }
            ADD      SP, 4
            PUSH     ES
            PUSH     DI
@@Exit_Point:
            POP      AX
            POP      DX
end;

function ProcessBlockByHandle(Handle : word) : PProcessBlock; assembler;
asm
            XOR      AX, AX
            PUSH     AX
            PUSH     AX
            CALL     LastProcessBlock
            OR       DX, DX
            JE       @@Exit_Point
            MOV      ES, DX
            MOV      DI, AX
            MOV      AH, ES:[DI].TProcessBlock.Multiplexor
            MOV      AL, 2
            MOV      BX, Handle
            XOR      DI, DI
            MOV      ES, DI
            ADD      SP, 4
            INT      2Fh
            PUSH     ES
            PUSH     DI
@@Exit_Point:
            POP      AX
            POP      DX
end;

procedure CallProcess(PB : PProcessBlock; var Regs : TCpuRegisters);
begin
  Regs.AH := PB^.Multiplexor;
  Regs.BX := PB^.Handle;
  _Int2Fh(Regs);       {  뢠 int 2Fh }
end;

function ComProcAvail(PB : PProcessBlock) : boolean; assembler;
asm
          LES     DI, PB
          MOV     AH, ES:[DI].TProcessBlock.Multiplexor
          MOV     AL, 3
          INT     2Fh
          OR      AL, AL
          JE      @@Set_True
          MOV     AL, FALSE
          JMP     @@Exit_Point
@@Set_True:
          MOV     AL, TRUE
@@Exit_Point:
end;

function ProcessInstalled(const Name : string; var PB : PProcessBlock) : boolean;
begin
                   {  -⥫   }
  PB := ProcessBlockByName(Name);
  ProcessInstalled := (PB <> nil);
end;

function InitProcessBlock(const AName : string;
                     AVersion : word;
                     ACommunication : pointer;
                     AResetInt : pointer;
                     ARestoreInt : pointer;
                     ASelfInt : pointer
                    ) : TInitProcessBlock;
var
  PB : PProcessBlock;
begin
    { ४⭠   }
  InitProcessBlock := ipbIncorrectDosVersion;
  if _DosVersion >= _RequiredDosVersion then
    begin
      InitProcessBlock := ipbOk;
      SelfNameLength := Length(AName) + 1;
      FillChar(SelfName, SizeOf(String), 0);
      asm
              PUSH      DS
              LDS       SI, AName
              XOR       CX, CX
              MOV       CL, BYTE PTR DS:[SI]
              OR        CX, CX
              JE        @@Skip_Conversion
              INC       SI
              CLD
              MOV       DI, SEG @DATA
              MOV       ES, DI
              MOV       DI, OFFSET SelfName
              REP       MOVSB
@@Skip_Conversion:
              POP       DS
      end;
      SelfPB.Version := AVersion;
      SelfPB.PSP := PrefixSeg;
      Move(ACommunication, Communication, SizeOf(Pointer));
      Move(AResetInt     , ResetInt     , SizeOf(Pointer));
      Move(ARestoreInt   , RestoreInt   , SizeOf(Pointer));
      Move(ASelfInt      , SelfInt      , SizeOf(Pointer));
      PB := LastProcessBlock;
      if PB = nil then
        begin
             { ᫨     ⠭, 饬 ᢮
               ⨯  । 80h...FFh }
          SelfPB.Handle := 1;
          asm
                   MOV      CH, 80h
@@Continue_Point:
                   MOV      AH, CH
                   MOV      AL, 0
                   INT      2Fh
                   CMP      AL, 0
                   JE       @@Reset_Multiplexor
                   CMP      CH, 0FFh
                   JE       @@Exit_Point
                   INC      CH
                   JMP      @@Continue_Point
@@Reset_Multiplexor:
                   MOV      SelfPB.Multiplexor, CH
@@Exit_Point:
          end;
          if SelfPB.Multiplexor = 0 then
            {  ⨯  }
            InitProcessBlock := ipbMultiplexorsBusy;
        end
      else
        begin
            {  ⨯  ᫥ 奭 }
          SelfPB.Multiplexor := PB^.Multiplexor;
          SelfPB.Handle := PB^.Handle;
          PB := ProcessBlockByName(AName);
          if PB <> nil then
            begin
                 {  㦥 ⠭ }
              InitProcessBlock := ipbAlreadyInstalled;
              if AVersion <> PB^.Version then
                  {  㣮 ᨨ 㦥 ⠭ }
                InitProcessBlock := ipbOtherVersionInstalled;
            end
          else
            begin
              if SelfPB.Handle = $FFFF then
                  {  奭  }
                InitProcessBlock := ipbHandlersBusy
              else
                Inc(SelfPB.Handle);
            end;
        end;
    end;
end;

var
  EnvReleased : boolean;

{$F+}
procedure NewInt2Fh; far; assembler;
asm
            PUSH     AX    { +16 }  { ࠭ ॣ }
            PUSH     BX    { +14 }
            PUSH     CX    { +12 }
            PUSH     DX    { +10 }
            PUSH     SI    { +08 }
            PUSH     DI    { +06 }
            PUSH     DS    { +04 }
            PUSH     ES    { +02 }
            PUSH     BP    { +00 }
            MOV      BP, SEG @DATA  { ந DS  BP }
            MOV      DS, BP
            MOV      BP, SP
            CMP      AH, SelfPB.Multiplexor  {  ⨯? }
            JNE      @@Go_Away               { ... }
            CMP      AL, 0                   { ஢ઠ ⠫樨? }
            JNE      @@Check_1               { ... }
            MOV      ES, [BP + 4]            { DS:SI  㪠뢠  Id }
            MOV      DI, [BP + 8]
            MOV      SI, OFFSET SelfPB
            CLD                              { ஢塞... }
            CMPSW
            JNE      @@Bad_ID                { .. }
            CMPSW
            JNE      @@Bad_ID                { ... }
            MOV      AX, [BP + 16]
            MOV      AL, 0FFh                { AL = Ok }
            MOV      [BP + 16], AX
@@Set_SelfPB_Addr:
            MOV      AX, SEG @DATA           { ES:DI 㪠뢠  SelfPB }
            MOV      [BP + 2], AX
            MOV      AX, OFFSET SelfPB
            MOV      [BP + 6], AX
@@Quit:
            POP      BP
            POP      ES
            POP      DS
            POP      DI
            POP      SI
            POP      DX
            POP      CX
            POP      BX
            POP      AX
            IRET
@@Bad_ID:
            MOV      AX, [BP + 16]
            MOV      AL, 01h            { AL = Busy }
            MOV      [BP + 16], AX
            JMP      @@Quit
@@Check_1:
            CMP      AL, 1              {   ? }
            JNE      @@Check_2          { ... }
            XOR      BX, BX
            MOV      [BP + 14], BX
            MOV      ES, [BP + 4]       { DS:SI 㪠뢠   }
            MOV      DI, [BP + 8]
            MOV      SI, OFFSET SelfName
            MOV      CX, SelfNameLength
            CLD
            REP      CMPSB              {  ᮢ? }
            CMP      CX, 0
            JNE      @@Go_Away          { ... }
            MOV      BX, SelfPB.Handle
            MOV      [BP + 14], BX
            JMP      @@Set_SelfPB_Addr
@@Check_2:
            CMP      AL, 2              {   奭? }
            JNE      @@Check_3          { ... }
            MOV      BX, [BP + 14]
            CMP      BX, SelfPB.Handle  {  奭? }
            JNE      @@Go_Away          { ... }
            JMP      @@Set_SelfPB_Addr
@@Check_3:
            CMP     AL, 3               { ஢ઠ 楤 㭨樨? }
            JNE     @@Check_User_Func   { ... }
            CMP     WORD PTR Communication [2], 0 { 楤 㭨樨 ? }
            JE      @@Quit              { ... }
            MOV     AX, [BP + 16]
            XOR     AL, AL
            MOV     [BP + 16], AX
            JMP     @@Quit
@@Check_User_Func:
            CMP     WORD PTR Communication [2], 0 { 楤 㭨樨 ? }
            JE      @@Quit              { ... }
            LES     BX, Communication
            JMP     @@Call_Int
@@Go_Away:
            LES      BX, SaveInt2Fh
@@Call_Int:
            MOV      AX, ES
            XCHG     AX, [BP + 16]
            XCHG     BX, [BP + 14]
            POP      BP
            POP      ES
            POP      DS
            POP      DI
            POP      SI
            POP      DX
            POP      CX
end;

function ReleaseProcess : boolean;
var
  RP : boolean;
begin
       { ஢塞   墠祭  뢠 }
  RP := SelfIntVec($2F,@NewInt2Fh);
  if RP and Assigned(SelfInt) then
    RP := RP and SelfInt;
  if RP then begin
        { ᫨ , ⠭  뢠 }
    if Assigned(RestoreInt) then RestoreInt;
    RestoreIntVec($2F,SaveInt2Fh);
    if not EnvReleased then asm
         { ᫨ 室, ᢮ ᥣ 㦥 }
              MOV    AX,SelfPB.PSP
              MOV    ES,AX
              MOV    ES,ES:[2CH]
              MOV    AH,49h
              INT    21h
    end;
         { ᢮ ,  ணࠬ }
    asm
              MOV    AX,SelfPB.PSP
              MOV    ES,AX
              MOV    AH,49h
              INT    21h
    end;
  end;
  ReleaseProcess := RP;
end;

function ParagraphsToKeep : Word;
begin
  ParagraphsToKeep := Succ(Seg(HeapPtr^)-PrefixSeg);
end;

function MaxParagraphsToKeep : Word;
var
  TopOfMem : pointer;
begin
  TopOfMem := Ptr(PrefixSeg, 2);
  MaxParagraphsToKeep := Word(TopOfMem^)-PrefixSeg;
end;

procedure InstallProcess(ParasToKeep: word; ReleaseEnv : boolean);
var
  SaveHeapEnd : pointer;
begin
  if (ParasToKeep < ParagraphsToKeep) or (ParasToKeep > MaxParagraphsToKeep)
      then Exit;
            {⠭ int- ࠭ RunTime Library }
  _SetIntVec($00, SaveInt00);
  _SetIntVec($02, SaveInt02);
  _SetIntVec($1B, SaveInt1B);
  _SetIntVec($23, SaveInt23);
  _SetIntVec($24, SaveInt24);
  _SetIntVec($34, SaveInt34);
  _SetIntVec($35, SaveInt35);
  _SetIntVec($36, SaveInt36);
  _SetIntVec($37, SaveInt37);
  _SetIntVec($38, SaveInt38);
  _SetIntVec($39, SaveInt39);
  _SetIntVec($3A, SaveInt3A);
  _SetIntVec($3B, SaveInt3B);
  _SetIntVec($3C, SaveInt3C);
  _SetIntVec($3D, SaveInt3D);
  _SetIntVec($3E, SaveInt3E);
  _SetIntVec($3F, SaveInt3F);
  _SetIntVec($75, SaveInt75);
            { ⠭ ॡ㥬 int- }
  if Assigned(ResetInt) then ResetInt;
  ResetIntVec($2F,@NewInt2Fh,SaveInt2Fh);
            { ।塞 娯 }
  SaveHeapEnd := HeapEnd;
  HeapEnd := Ptr(PrefixSeg+ParasToKeep, 0);
  EnvReleased := ReleaseEnv;
            { ᫨ 室, ᢮ ᥣ 㦥 }
  if ReleaseEnv then asm
            MOV      AH,49h
            MOV      ES,CS:[2Ch]
            INT      21h
  end;
  asm       { ⠥  १⮬ }
            MOV       AX,3100h
            MOV       DX,ParasToKeep
            INT       21h
  end;
            {  !!! }
  HeapEnd := SaveHeapEnd;
  RestoreIntVec($2F,SaveInt2Fh);
  if Assigned(RestoreInt) then RestoreInt;
end;

type
  WordRec = record
    Lo, Hi: Byte;
  end;

procedure RequiredDosVersion(Major, Minor : byte);
begin
  WordRec(_RequiredDosVersion).Hi := Major;
  WordRec(_RequiredDosVersion).Lo := Minor;
  if _RequiredDosVersion < $031E then
    _RequiredDosVersion := $031E;
end;

{$ENDIF}

function VersionStr(Version : word) : string;
var
  HiVer : string[3];
  LoVer : string[3];
begin
  Str(Hi(Version), HiVer);
  Str(Lo(Version), LoVer);
  if (Length(LoVer) = 1) and (LoVer[1] <> '0') then
    LoVer := '0' + LoVer;
  VersionStr := HiVer + '.' + LoVer;
end;

function ProjectStr(PrjStart, PrjEnd : word) : string;
var
  PrjStartStr, PrjEndStr : string[5];
begin
  Str(PrjStart, PrjStartStr);
  Str(PrjEnd,   PrjEndStr);
  ProjectStr := PrjStartStr;
  if PrjStart = PrjEnd then
    ProjectStr := PrjStartStr
  else
    ProjectStr := PrjStartStr + ',' + PrjEndStr;
end;

function Copyright(const Name : string; Version : word;
                   ProjectStart, ProjectEnd : word;
                   const Producer : string) : string;
begin
  Copyright := Name + #32#32 +
               'Version ' + VersionStr(Version) + #32#32 +
               'Copyright (c) ' + ProjectStr(ProjectStart, ProjectEnd) +
               #32#32 + Producer;
end;

end.   { end of file COMINT2F.PAS }
